Name: collectd
Version: 4.4.1
Release: alt3

Summary: Statistics collection for filling RRD files
License: GPL
Group: Monitoring

Url: http://collectd.org
Source0: %url/files/%name-%version.tar.bz2
Source1: %name.init
Source2: %name.conf
Source3: %name.htaccess
Packager: Michael Shigorin <mike@altlinux.org>

Requires: rrdtool

%def_disable static

%def_with cgi
%def_with mysql
%def_with sensors
%def_with snmp
%def_with xmms

%ifarch x86_64
%def_without nut
%else
%def_with nut
%endif

%set_verify_elf_method unresolved=relaxed textrel=relaxed
%define conffile %_sysconfdir/%name.conf
%define rrddir %_localstatedir/%name

# backup
#BuildRequires: gcc-c++ iptables-devel libcurl-devel libpcap-devel librrd-devel libuuid-devel libxfs-devel perl-HTML-Parser perl-devel rrd-perl
#BuildRequires: flex gcc-c++ libcurl-devel libnetlink-devel libpcap-devel librrd-devel libxml2-devel perl-devel

# Automatically added by buildreq on Thu Jun 26 2008 (-bi)
BuildRequires: flex gcc-c++ libcurl-devel libnetlink-devel libpcap-devel librrd-devel libxml2-devel perl-devel
BuildRequires: perl-HTML-Parser rrd-perl
BuildRequires: libnetlink-devel libstatgrab-devel

%if_with apache
BuildRequires(pre): apache2-devel
%endif

%if_with cgi
BuildRequires: perl-CGI 
BuildRequires(pre): apache2-devel
%endif

%if_with mysql
BuildRequires: libMySQL-devel 
%endif

%if_with sensors
BuildRequires: libsensors-devel
%endif

%if_with snmp
BuildRequires: libnet-snmp-devel
%endif

%if_with nut
BuildRequires: nut-devel
%endif

%if_with xmms
BuildRequires: libxmms-devel
%endif

%description
collectd is a small program written in C for performance. It reads various
system statistics and updates RRD files, creating them if neccessary.
Since it doesn't need to startup every time it wants to update the files
it's very fast and easy on the system. Also, the statistics are very
fine grained since the files are updated every 10 seconds.

WARNING: 4.x is INCOMPATIBLE with 3.x data!  You have to perform
custom migration as described in documentation or drop the history!

%if_with cgi
%package cgi
Summary: CGI script for collectd
Group: Monitoring
Requires: collectd = %version
Requires: perl

%description cgi
This CGI frontend for collectd allows to browse the stats online.
Check http://localhost/cgi-bin/collectd/collection.cgi
%endif

%if_with mysql
%package mysql
Summary: MySQL support module for collectd
Group: Monitoring
Requires: collectd = %version-%release
Requires: libMySQL

%description mysql
This plugin for collectd provides querying of MySQL server
%endif

%if_with sensors
%package sensors
Summary: lm_sensors support module for collectd
Group: Monitoring
Requires: collectd = %version-%release
Requires: lm_sensors

%description sensors
This plugin for collectd provides querying of sensors supported
by lm_sensors
%endif

%if_with snmp
%package snmp
Summary: SNMP support module for collectd
Group: Monitoring
Requires: collectd = %version-%release
Requires: libnet-snmp

%description snmp
This plugin for collectd provides querying via SNMP
%endif

%if_with nut
%package nut
Summary: UPS support module for collectd
Group: Monitoring
Requires: collectd = %version-%release
Requires: libnut

%description nut
This plugin for collectd provides querying UPS via NUT
%endif

%if_with xmms
%package xmms
Summary: XMMS support module for collectd
Group: Monitoring
Requires: collectd = %version-%release
Requires: libxmms

%description xmms
This plugin for collectd provides querying of XMMS
%endif

%package -n nagios-plugins-%name
Summary: Nagios plugin to use data from collectd
Group: Monitoring
Requires: nagios-common

%description -n nagios-plugins-%name
This Nagios plugin provides possibility to feed statistics
from collectd into nagios to avoid extra sensor-caused load

%prep
%setup -q
subst 's/ -Werror//' src/Makefile.*

%build
CONFFLAGS="--disable-apple_sensors"

%if_without apache
CONFFLAGS="$CONFFLAGS --disable-apache"
%endif

%if_without mysql
CONFFLAGS="$CONFFLAGS --disable-mysql"
%endif

%if_without sensors
CONFFLAGS="$CONFFLAGS --disable-sensors"
%endif

%if_without snmp
CONFFLAGS="$CONFFLAGS --disable-snmp"
%endif

%if_without nut
CONFFLAGS="$CONFFLAGS --disable-nut"
%endif

%if_without xmms
CONFFLAGS="$CONFFLAGS --disable-xmms"
%endif

# didn't help
%add_optflags -Wno-unused

# all mainstreams uses localstatedir as var, but ALT set in in /var/lib :(
autoreconf -fisv
%configure $CONFFLAGS %{subst_enable static} --localstatedir=%_var
%make

%install
%make_install DESTDIR=%buildroot install
install -pD -m644 src/collectd.conf %buildroot%conffile
install -pD -m755 %SOURCE1 %buildroot%_initdir/%name
install -d %buildroot%_libdir/%name/ %buildroot%rrddir
rm -f %buildroot%_libdir/%name/*.la

sed -i 's,/usr/var,/var,g' %buildroot%conffile

%if_with cgi
install -pD -m755 contrib/collection.cgi %buildroot%apache_cgibindir/%name/collection.cgi
install -pD -m0644 %SOURCE2 %buildroot%apache_confdir/addon-modules.d/%name.conf
install -pD -m0644 %SOURCE3 %buildroot%apache_cgibindir/%name/.htaccess
cat >> %buildroot%_sysconfdir/collection.conf << EOF
datadir: "%rrddir"
libdir: "%rrddir"
EOF
%endif

%pre
[ -s %conffile ] || exit 0

egrep -q '^Mode[	 ]+(Local|Server|Client|Log)' %conffile && {
	cat << EOF >&2
WARNING: collectd-3.x configuration found,
         preserving existing %conffile
	 (you will need to review/update it):
EOF
	[ ! -s %conffile ] || mv -v --backup=numbered %conffile %{conffile}-3.x
}

%post
%post_service %name

ls %rrddir/*.rrd >&/dev/null && cat << EOF >&2
WARNING: collectd-3.x data found in %rrddir/;
         if you need them (e.g. for historical overview),
	 please read contrib/README in documentation 
	 (http://collectd.org/migrate-v3-v4.shtml)
	 and use migrate-3-4.px script
EOF
:

%preun
%preun_service %name

%if_with cgi
# FIXME: httpd/httpd2? need subpackages
%post cgi
%_initdir/httpd condrestart 1>&2
%endif

%files
%doc AUTHORS ChangeLog README TODO
%doc contrib/
%config(noreplace) %conffile
%_initdir/%name
%_sbindir/%name
%_sbindir/collectdmon
%_man1dir/*.1*
%_man5dir/*.5*
%dir %_libdir/%name/
%dir %rrddir/
%_libdir/%name/*.so*
%_libdir/%name/types.db

%if_with mysql
%exclude %_libdir/%name/mysql.so*
%endif

%if_with nut
%exclude %_libdir/%name/nut.so*
%endif

%if_with sensors
%exclude %_libdir/%name/sensors.so*
%endif

%if_with snmp
%exclude %_libdir/%name/snmp.so*
%endif

%if_with xmms
%exclude %_libdir/%name/xmms.so*
%endif

%if_with cgi
%files cgi
%dir %apache_cgibindir/%name/
%apache_cgibindir/%name/collection.cgi
%config(noreplace) %apache_cgibindir/%name/.htaccess
%config(noreplace) %apache_confdir/addon-modules.d/%name.conf
%config(noreplace) %_sysconfdir/collection.conf
%endif

%if_with mysql
%files mysql
%_libdir/%name/mysql.so*
%endif

%if_with sensors
%files sensors
%_libdir/%name/sensors.so*
%endif

%if_with snmp
%files snmp
%_libdir/%name/snmp.so*
%endif

%if_with nut
%files nut
%_libdir/%name/nut.so*
%endif

%if_with xmms
%files xmms
%_libdir/%name/xmms.so*
%endif

%files -n nagios-plugins-%name
%_bindir/collectd-nagios

# TODO:
# - auto-hostname seems broken
# - httpd-dependent subpackages?
# - consider:
#   + libiokit
#   + libiptc
#   + libkvm
#   + libvirt
#   + libperl
#   + libstatgrab
#   + liboping/liboconfig (system)
#   + ipmi
#   + ipvs (kernel-headers-modules-std)
# - perl subpackage:
#   warning: Installed (but unpackaged) file(s) found:
#    /usr/lib/perl5/i386-linux/perllocal.pod
#    /usr/lib/perl5/site_perl/5.8.8/Collectd.pm
#    /usr/lib/perl5/site_perl/5.8.8/Collectd/Unixsock.pm
#    /usr/share/man/man3/Collectd::Unixsock.3pm.gz
# - FR: filter host.name/load/load -> host.name/load
# - FR: name translation so e.g. sensor graphs
#   become comparable between hosts
# - FR: multihost graphs per plugin/value

%changelog
* Sat Jun 28 2008 Michael Shigorin <mike@altlinux.org> 4.4.1-alt3
- disabled nut plugin on x86_64 by default (see #16197)

* Fri Jun 27 2008 Michael Shigorin <mike@altlinux.org> 4.4.1-alt2
- removed apache-common requirement from cgi subpackage
- added installation-time warning regarding 3.x data/config
  (these aren't overwritten but might need migration)

* Thu Jun 26 2008 Michael Shigorin <mike@altlinux.org> 4.4.1-alt1
- 4.4.1: yeah, I've skipped quite a few 4.x releases while
  trying to get back to this package... now's about time ;-)

* Sun Feb 10 2008 Michael Shigorin <mike@altlinux.org> 4.2.4-alt3
- enabled features:
  + libnetlink, libstatgrab (core package)
  + snmp, nut, xmms (subpackages)

* Sun Feb 10 2008 Michael Shigorin <mike@altlinux.org> 4.2.4-alt2
- removed patches

* Tue Jan 22 2008 Michael Shigorin <mike@altlinux.org> 4.2.4-alt1
- 4.2.4 (major feature enhancements [over 4.0])
  + built for Daedalus
  + note http://collectd.org/migrate-v3-v4.shtml
    or wipe %_localstatedir/%name/ clean of collected data

* Tue Aug 14 2007 Michael Shigorin <mike@altlinux.org> 4.0.6-alt1
- 4.0.6 (major feature enhancements)
  + warning, there are major RRD- and CGI-related changes!
    you should not update the package blindly if it is used
  + please see contrib/migrate-3-4.px and associated README
- added apache2-devel, perl-devel to BuildRequires
- enabled apache2 subpackage by default
- introduced sample /etc/collection.conf (adapted from git)

* Thu May 31 2007 Michael Shigorin <mike@altlinux.org> 3.11.5-alt1
- 3.11.5 (security fixes)
  + fixed buffer overflow in the ntpd plugin
  + fixed support for Linux 2.4 in the disk plugin
  + added large file support (LFS)

* Tue Apr 03 2007 Michael Shigorin <mike@altlinux.org> 3.11.3-alt1
- 3.11.3 (minor bugfixes)

* Sat Feb 10 2007 Michael Shigorin <mike@altlinux.org> 3.11.1-alt1
- 3.11.1 (minor bugfixes)

* Sun Jan 28 2007 Michael Shigorin <mike@altlinux.org> 3.11.0-alt1
- 3.11.0
- removed patch1 (fixed upstream)
- fixed build with recent gcc4.1 (removed -Werror since -Wno-unused
  wouldn't  help)

* Fri Dec 22 2006 Michael Shigorin <mike@altlinux.org> 3.10.3-alt1
- thanks Vitaly Lipatov (lav@) for fixing build (patch sent upstream)
  and other improvements
- service off by default, see also [ru]:
  http://lists.altlinux.org/pipermail/devel/2006-December/039909.html

* Sat Dec 09 2006 Vitaly Lipatov <lav@altlinux.ru> 3.10.3-alt0.2
- NMU: set config as noreplace
- add post/preun service

* Mon Nov 20 2006 Vitaly Lipatov <lav@altlinux.ru> 3.10.3-alt0.1
- NMU: new version 3.10.3
- fix compiling (remove syslog redefine)
- fix default paths in /var (bug #10237)
- move cgi script to cgi/collectd dir
- add .htaccess, collectd.conf for apache

* Sun Sep 17 2006 Michael Shigorin <mike@altlinux.org> 3.10.1-alt2
- accepted spec patch from lakostis@
  + NMU.
  + .spec cleanup.
  + remove unwanted buildrequires.
  + build with system libltdl.
  + build with linux-libc-headers.
  + disable -static builds by default.
- fixed collectd.conf installation (source file moved)

* Sat Aug 05 2006 Michael Shigorin <mike@altlinux.org> 3.10.1-alt1
- 3.10.1

* Sun Jun 18 2006 Michael Shigorin <mike@altlinux.org> 3.9.3-alt1
- 3.9.3 (minor bugfixes)

* Mon May 15 2006 Michael Shigorin <mike@altlinux.org> 3.9.2-alt1
- 3.9.2 (minor bugfixes)
  + ping plugin would stop working after roughly one week
    with default settings

* Fri Apr 28 2006 Michael Shigorin <mike@altlinux.org> 3.9.1-alt1
- 3.9.1

* Sun Apr 23 2006 Michael Shigorin <mike@altlinux.org> 3.9.0-alt2
- macro control over modules (subpackages) built:
  apache, cgi, mysql, sensors (the rest is in the main package)

* Fri Apr 21 2006 Michael Shigorin <mike@altlinux.org> 3.9.0-alt1
- 3.9.0
- updated buildrequires for new plugins
- added mysql subpackage
- added cgi subpackage (WARNING: unrestricted out-of-box)
- patched hddtemp module regarding higher SCSI majors
- disabled apache support for the time being
- disabled apple sensors
- remove (unpackaged) *.la too

* Fri Apr 07 2006 Michael Shigorin <mike@altlinux.org> 3.8.3-alt1
- 3.8.3

* Wed Mar 15 2006 Michael Shigorin <mike@altlinux.org> 3.8.2-alt1
- 3.8.2
- built for Sisyphus
- sample configuration file taken from contrib/ now
  *and* moved to %_sysconfdir/%name.conf [3.8.1-1 spec]
- I've not got around to make this all work more out-of-box, spec fixes
  are welcome but maybe it's better as is (setup isn't that hard)

* Wed Mar 15 2006 Michael Shigorin <mike@altlinux.org> 3.8.0-alt1
- 3.8.0

* Tue Jan 31 2006 Michael Shigorin <mike@altlinux.org> 3.7.0-alt0.M24.1
- 3.7.0

* Mon Dec 19 2005 Michael Shigorin <mike@altlinux.org> 3.5.1-alt0.M24.1
- 3.5.1
- spec cleanup

* Mon Dec 05 2005 Michael Shigorin <mike@altlinux.org> 3.4.0-alt0.M24.1
- 3.4.0

* Wed Nov 09 2005 Michael Shigorin <mike@altlinux.org> 3.3.0-alt0.M24.1
- 3.3.0

* Thu Oct 27 2005 Michael Shigorin <mike@altlinux.org> 3.2.0-alt0.M24.1
- 3.2.0

* Mon Oct 17 2005 Michael Shigorin <mike@altlinux.org> 3.1.0-alt0.M24.1
- built for ALT Linux Master 2.4
- spec cleanup

* Fri Sep 30 2005 Florian octo Forster <octo@verplant.org> 3.0.0-1
- New upstream version
- Split the package into `collectd' and `collectd-sensors'

* Fri Sep 16 2005 Florian octo Forster <octo@verplant.org> 2.1.0-1
- New upstream version

* Mon Sep 10 2005 Florian octo Forster <octo@verplant.org> 2.0.0-1
- New upstream version

* Mon Aug 29 2005 Florian octo Forster <octo@verplant.org> 1.8.0-1
- New upstream version

* Sun Aug 25 2005 Florian octo Forster <octo@verplant.org> 1.7.0-1
- New upstream version

* Sun Aug 21 2005 Florian octo Forster <octo@verplant.org> 1.6.0-1
- New upstream version

* Sun Jul 17 2005 Florian octo Forster <octo@verplant.org> 1.5.1-1
- New upstream version

* Sun Jul 17 2005 Florian octo Forster <octo@verplant.org> 1.5-1
- New upstream version

* Mon Jul 11 2005 Florian octo Forster <octo@verplant.org> 1.4.2-1
- New upstream version

* Sat Jul 09 2005 Florian octo Forster <octo@verplant.org> 1.4-1
- Built on RedHat 7.3
